summaryrefslogtreecommitdiff
path: root/client
diff options
context:
space:
mode:
authorChristian Pointner <equinox@spreadspace.org>2015-10-12 07:06:46 +0200
committerChristian Pointner <equinox@spreadspace.org>2015-10-12 07:06:46 +0200
commit4dc69dee6fc389a8661ede469df70b8bea222994 (patch)
tree851d126d28080ce2efd4cd381791adc220caaf60 /client
parentmoved apps to server (diff)
added inital client codebase
Diffstat (limited to 'client')
-rw-r--r--client/Makefile83
-rwxr-xr-xclient/configure152
-rw-r--r--client/dolmetschctl-client.c183
3 files changed, 418 insertions, 0 deletions
diff --git a/client/Makefile b/client/Makefile
new file mode 100644
index 0000000..a353d9d
--- /dev/null
+++ b/client/Makefile
@@ -0,0 +1,83 @@
+##
+## dolmetschctl
+##
+##
+## Copyright (C) 2015 Christian Pointner <equinox@spreadspace.org>
+##
+## This file is part of dolmetschctl.
+##
+## dolmetschctl is free software: you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation, either version 3 of the License, or
+## any later version.
+##
+## dolmetschctl is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with dolmetschctl. If not, see <http://www.gnu.org/licenses/>.
+##
+
+ifneq ($(MAKECMDGOALS),distclean)
+include include.mk
+endif
+
+EXECUTABLE := dolmetschctl-client
+
+C_OBJS := dolmetschctl-client.o
+
+C_SRCS := $(C_OBJS:%.o=%.c)
+
+.PHONY: clean distclean install install-bin uninstall remove remove-bin
+
+all: $(EXECUTABLE)
+
+%.d: %.c
+ @set -e; rm -f $@; \
+ $(CC) -MM $(CFLAGS) $< > $@.$$$$; \
+ sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
+ rm -f $@.$$$$; echo '(re)building $@'
+
+ifneq ($(MAKECMDGOALS),distclean)
+-include $(C_SRCS:%.c=%.d)
+endif
+
+$(EXECUTABLE): $(C_OBJS)
+ $(CC) $(C_OBJS) -o $@ $(LDFLAGS)
+
+%.o: %.c
+ $(CC) $(CFLAGS) -c $<
+
+strip: $(EXECUTABLE)
+ $(STRIP) -s $(EXECUTABLE)
+
+
+distclean: clean
+ find . -name *.o -exec rm -f {} \;
+ find . -name "*.\~*" -exec rm -rf {} \;
+ rm -f include.mk
+ rm -f config.h
+
+clean:
+ rm -f *.o
+ rm -f *.d
+ rm -f *.d.*
+ rm -f $(EXECUTABLE)
+
+INSTALL_TARGETS := install-bin
+REMOVE_TARGETS := remove-bin
+
+install: all $(INSTALL_TARGETS)
+
+install-bin: $(EXECUTABLE)
+ $(INSTALL) -d $(DESTDIR)$(BINDIR)
+ $(INSTALL) -m 755 $(EXECUTABLE) $(DESTDIR)$(BINDIR)
+
+uninstall: remove
+
+remove: $(REMOVE_TARGETS)
+
+remove-bin:
+ rm -f $(DESTDIR)$(BINDIR)/$(EXECUTABLE)
diff --git a/client/configure b/client/configure
new file mode 100755
index 0000000..9c5109f
--- /dev/null
+++ b/client/configure
@@ -0,0 +1,152 @@
+#!/bin/sh
+#
+# dolmetschctl
+#
+#
+# Copyright (C) 2015 Christian Pointner <equinox@spreadspace.org>
+#
+# This file is part of dolmetschctl.
+#
+# dolmetschctl is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# any later version.
+#
+# dolmetschctl is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with dolmetschctl. If not, see <http://www.gnu.org/licenses/>.
+#
+
+TARGET=`uname -s`
+EBUILD_COMPAT=0
+
+USE_CLANG=0
+
+PREFIX='/usr/local'
+BINDIR=''
+
+print_usage() {
+ echo "configure --help print this"
+ echo " --target=<TARGET> build target i.e. Linux (default: autodetect)"
+ echo " --prefix=<PREFIX> the installation prefix (default: /usr/local)"
+ echo " --bindir=<DIR> the path to the bin directory (default: $PREFIX/bin)"
+ echo " --use-clang use clang/llvm as compiler/linker"
+}
+
+for arg
+do
+ case $arg in
+ --target=*)
+ TARGET=${arg#--target=}
+ ;;
+ --use-clang)
+ USE_CLANG=1
+ ;;
+ --prefix=*)
+ PREFIX=${arg#--prefix=}
+ ;;
+ --bindir=*)
+ BINDIR=${arg#--bindir=}
+ ;;
+ --ebuild-compat)
+ EBUILD_COMPAT=1
+ ;;
+ --help)
+ print_usage
+ exit 0
+ ;;
+ *)
+ ERRORS="$ERRORS $arg"
+ ;;
+ esac
+done
+
+if [ -n "$ERRORS" ] && [ $EBUILD_COMPAT -ne 1 ]; then
+ for error in $ERRORS; do
+ echo "Unknown argument: $error"
+ done
+
+ print_usage
+ exit 1
+fi
+
+if [ $USE_CLANG -eq 0 ]; then
+ CFLAGS='-g -Wall -O2'
+ LDFLAGS='-g -Wall -O2'
+ COMPILER='gcc'
+else
+ CFLAGS='-g -O2'
+ LDFLAGS='-g -O2'
+ COMPILER='clang'
+fi
+
+rm -f config.h
+rm -f include.mk
+case $TARGET in
+ Linux)
+ LDFLAGS=$LD_FLAGS' -lasound -llo'
+ ;;
+ *)
+ echo "platform not supported"
+ exit 1;
+ ;;
+esac
+
+if [ -z "$BINDIR" ]; then
+ BINDIR=$PREFIX/bin
+fi
+
+cat > include.mk <<EOF
+# this file was created automatically
+# do not edit this file directly
+# use ./configure instead
+
+TARGET := $TARGET
+CC := $COMPILER
+CFLAGS := $CFLAGS
+LDFLAGS := $LDFLAGS
+STRIP := strip
+INSTALL := install
+
+prefix := '$PREFIX'
+BINDIR := '$BINDIR'
+EOF
+
+VERSION=`cat ../version`
+if which git >/dev/null; then
+ GIT_HASH=`git rev-parse HEAD 2> /dev/null`
+ if [ -n "$GIT_HASH" ]; then
+ VERSION="$VERSION (git $GIT_HASH)"
+ fi
+fi
+
+HOSTNAME=`hostname`
+DATE=`date +"%d.%m.%Y %H:%M:%S %Z"`
+
+cat > config.h <<EOF
+/*
+ * dolmetschctl config header
+ *
+ * this file was created automatically
+ * do not edit this file directly
+ * use ./configure instead
+ */
+
+#ifndef DOLMETSCHCTL_config_h_INCLUDED
+#define DOLMETSCHCTL_config_h_INCLUDED
+
+#define VERSION_STRING_0 "dolmetschctl version $VERSION"
+#define VERSION_STRING_1 "built on $HOSTNAME, $DATE"
+
+#define TARGET "$TARGET"
+#define PREFIX "$PREFIX"
+#define BINDIR "$BINDIR"
+
+#endif
+EOF
+
+exit 0
diff --git a/client/dolmetschctl-client.c b/client/dolmetschctl-client.c
new file mode 100644
index 0000000..e001db9
--- /dev/null
+++ b/client/dolmetschctl-client.c
@@ -0,0 +1,183 @@
+/*
+ * dolmetschctl
+ *
+ *
+ * Copyright (C) 2015 Christian Pointner <equinox@spreadspace.org>
+ *
+ * This file is part of dolmetschctl.
+ *
+ * dolmetschctl is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * any later version.
+ *
+ * dolmetschctl is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with dolmetschctl. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "config.h"
+
+#include <stdio.h>
+#include <unistd.h>
+#include <ctype.h>
+#include <error.h>
+
+#include <lo/lo.h>
+#include <alsa/asoundlib.h>
+
+/* #include "midi.h" */
+/* #include "osc.h" */
+
+
+void print_version()
+{
+ printf("%s\n", VERSION_STRING_0);
+#if defined(__clang__)
+ printf("%s, using CLANG %s\n", VERSION_STRING_1, __clang_version__);
+#elif defined(__GNUC__)
+ printf("%s, using GCC %d.%d.%d\n", VERSION_STRING_1, __GNUC__, __GNUC_MINOR__, __GNUC_PATCHLEVEL__);
+#else
+ printf("%s\n", VERSION_STRING_1);
+#endif
+
+ printf("linked against alsa-lib Version %s\n", snd_asoundlib_version());
+ char verstr[32];
+ lo_version(verstr, sizeof(verstr), 0, 0, 0, 0, 0, 0, 0);
+ printf("linked against liblo Version %s\n", verstr);
+}
+
+void print_usage()
+{
+ printf("\ndolmetschctl-client <options>\n");
+ printf(" -h print this and exit\n");
+ printf(" -v print version information and exit\n");
+ printf(" -m <dev> the MIDI control device name to use, i.e. hw:2,0,0\n");
+ printf(" (use `amidi -l` to list all available devices)'\n");
+ printf(" -o <host>:<port> the UDP host/port to send OSC messages to\n");
+}
+
+/* int main_loop(midi_t* m, osc_t* o) */
+int main_loop()
+{
+ int ret = 0;
+
+ printf("main_loop just started\n");
+
+ /* int midi_npfds_offset = 0; */
+ /* int midi_npfds = midi_get_poll_fd_count(m); */
+ /* assert(midi_npfds > 0); */
+
+ /* int osc_npfds_offset = midi_npfds_offset + midi_npfds; */
+ /* int osc_npfds = osc_get_poll_fd_count(o); */
+ /* assert(osc_npfds > 0); */
+
+ int npfds = 0; //midi_npfds + osc_npfds;
+ struct pollfd *pfds = alloca(npfds * sizeof(struct pollfd));
+ if(!pfds) {
+ error(0, 0, "error while allocating poll fds - stack corrupted??");
+ return -1;
+ }
+
+ printf("main_loop running with %d pollfds...\n", npfds);
+ for (;;) {
+ /* midi_get_poll_fds(m, &(pfds[midi_npfds_offset]), midi_npfds); */
+ /* osc_get_poll_fds(o, &(pfds[osc_npfds_offset]), osc_npfds); */
+
+ int err = poll(pfds, npfds, 200);
+ if(err < 0 && errno != EINTR) {
+ error(0, errno, "poll failed");
+ break;
+ }
+ if(err <= 0) {
+ // timeout or EINTR
+ continue;
+ }
+
+ /* ret = midi_handle_revents(m, &(pfds[midi_npfds_offset]), midi_npfds, x); */
+ /* if(ret) */
+ /* break; */
+
+ /* ret = osc_handle_revents(o, &(pfds[osc_npfds_offset]), osc_npfds, x); */
+ /* if(ret) */
+ /* break; */
+ }
+
+ return ret;
+}
+
+int main(int argc, char* argv[])
+{
+ int helpflag = 0;
+ int versionflag = 0;
+ char* midi_dev = NULL;
+ char* osc_target = NULL;
+
+ int c;
+ opterr = 0;
+ while ((c = getopt (argc, argv, "vhm:o:")) != -1) {
+ switch (c) {
+ case 'h':
+ helpflag = 1;
+ break;
+ case 'v':
+ versionflag = 1;
+ break;
+ case 'm':
+ midi_dev = optarg;
+ break;
+ case 'o':
+ osc_target = optarg;
+ break;
+ case '?':
+ if (optopt == 'm' || optopt == 'o')
+ error(0, 0, "Option -%c requires an argument.\n", optopt);
+ else if (isprint (optopt))
+ error(0, 0, "Unknown option `-%c'.\n", optopt);
+ else
+ error(0, 0, "Unknown option character `\\x%x'.\n", optopt);
+ return -1;
+ default:
+ return -1;
+ }
+ }
+
+ if(helpflag) {
+ print_usage();
+ return 0;
+ }
+
+ if(versionflag) {
+ print_version();
+ return 0;
+ }
+
+ if(!midi_dev){
+ error(0, 0, "MIDI device name must be set");
+ print_usage();
+ return -1;
+ }
+
+ if(!osc_target){
+ error(0, 0, "OSC target (host/port) name must be set");
+ print_usage();
+ return -1;
+ }
+
+ /* midi_t m; */
+ /* if(midi_init(&m, midi_dev)) */
+ /* return -1; */
+
+ /* osc_t o; */
+ /* if(osc_init(&o, osc_target)) */
+ /* return -1; */
+
+ /* int ret = main_loop(&m, &o); */
+ int ret = main_loop();
+
+ return ret;
+}